val get_homepage :  int -> string option
val compute_depends: Common.package -> unit


(* transform to_do and changed_options to a wish list.
   default values: min_int,Gl.to_do and Gl.changed_options *)
val get_cur_wl:
  ?to_do:Common.to_do array
  -> ?changed_options:string Common.SHashtbl.t Common.SHashtbl.t
  -> unit
  -> Common.wish list

val check_plan: ?force_rescan: bool -> ?wl: Common.wish list -> unit -> Common.plan_t

val use_conf_from_wl: Common.wish list -> unit

val apply_plan: Common.plan_t -> unit


type cpl = [
|`Name of string
|`Identifier of Common.binary_identifier
]

val check_plan_local:
  to_do:Common.to_do array ->
  wl:Common.wish list ->
  pl:Common.plan_to_do list ->
  (cpl * string) list

(*
type cpl_error = {
  not_removable: Common.package list;
  not_installable: Common.package list;
}

type cpl_new_consequences = {
  depending_builds: Common.package list;
  depending_adds: Common.package list;
  depending_removals: Common.package list;
  updated_source_packages: Common.package list;
  downgraded_source_packages: Common.package list;
  rebuilded_source_packages: Common.package list;
  updated_binary_packages: Common.package list;
  downgraded_binary_packages: Common.package list;
  replaced_binary_packages: Common.package list;
}

type cpl_new =
| Cpl_ok
| Cpl_error of cpl_error
| Cpl_new_consequences of cpl_new_consequences


val check_plan_local_new:
  to_do:Common.to_do array ->
  pl:Common.plan_to_do list ->
  cpl_new
*)


(* test if it is_possible to apply the new to_do list
   this function will ask for user input if necessary
*)
val try_apply_to_do: Common.to_do array -> bool
