type run = {
  command: string;
  args: string array;
  killable: bool ; (* whether we should kill the process or not if something goes wrong *)
  (* informal description. Will be displayed if something goes wrong *)
  description: string;
  env: string array option;
}

type t =
| Ok
| Error of run list (* not or only partially runned jobs *)
| Aborted of run list (* see above *)

val run :
  ?width:int ->
  ?height:int ->
  ?icon:GdkPixbuf.pixbuf ->
  ?success_message:string ->
  ?auto_close:bool ->
  window_title:string ->
  run list ->
  t
