

type error =
  | File_exists

exception EcurlExeception of error * string


val get_filename_from_url: string -> string option

type referer_option =
  | Referer_disable
  | Referer_fake
  | Referer of string

type file_exist_action =
  | Overwrite
  | Inform of (string -> unit)
  | Stop

class ecurl :
  ?user_agent:string ->
  ?use_cookies:bool ->
(*  ?proxy_kind:Curl.curlProxy option ->
  ?proxy_address:string -> *)
  ?default_referer:referer_option ->
  unit ->
  object
    method get :
      ?referer:referer_option -> string -> string
    method post :
      ?referer:referer_option -> ?files:(string * string) list -> (string * string) list -> string -> string
    method get2file :
      ?referer:referer_option -> ?fprogress:(float -> float -> float -> float -> bool) -> file:string -> string -> unit
    method get2dir :
      ?referer:referer_option -> ?fprogress:(float -> float -> float -> float -> bool) -> ?ask:file_exist_action -> dir:string -> string -> unit
  end
