(* dummy class, curl not needed on *nix *)
type referer_option =
  | Referer_disable
  | Referer_fake
  | Referer of string

type file_exist_action =
| Overwrite
| Inform of (string -> unit)
| Stop

let default_user_agent = "Netclient"
let default_referer = Referer_fake

type error = | File_exists

exception EcurlExeception of error * string

let get_filename_from_url url =
  try
    let p = String.rindex url '/' in
    match String.sub url (succ p) ( (String.length url) - p - 1 ) with
      | "" -> None
      | x -> Some x
  with
    | Not_found -> None


class ecurl
  ?(user_agent=default_user_agent)
  ?(use_cookies=false)
  ?(default_referer=default_referer)
  ()
  =
object (self)
  method get
    ?(referer=default_referer)
    (url:string) =
    ""

  method post
    ?(referer=default_referer)
    ?(files:(string*string) list option)
    (params:(string*string) list)
    (url:string) =
    ""

  method get2file ?(referer=default_referer)
    ?(fprogress:(float -> float -> float -> float -> bool) option)
    ~(file:string) (s:string) =
    ()

  method get2dir
    ?(referer=default_referer)
    ?(fprogress:(float -> float -> float -> float -> bool) option)
    ?(ask:file_exist_action option)
    ~(dir:string)
    (s:string) =
    ()

end
