(* netsys shell doesn't seem to work properly on windows  *)

type io_out =
    [ `Buffer of Buffer.t
    | `Fun of string -> unit
    | `Null
    | `Stderr
    | `Stdout ]

type io_in = [ `Null | `String of string ]
type t

(* run command *)
val run : t -> unit

(* kill running command *)
val kill : t -> unit

(*
  wait until t is finished, return it's exit code
  never call close before run
*)
val close : t -> int

val new_command :
  ?env:string array ->
  ?stdin:io_in ->
  ?stdout:io_out ->
  ?stderr:io_out ->
  string ->
  string list ->
  t


val wait_exit: unit -> unit
