type split = Nosplit | First_last of string * string

val executable_name : string

val split_one : string -> char -> split
val split_rev : string -> char -> string list
val split : string -> char -> string list
val remove_spaces_begin_end : string -> string

val list_unique : 'a list -> 'a list

val list_partition_by_number: 'a list -> int -> 'a list * 'a list


val try_finally: ('a -> 'b) -> 'a -> ('c -> 'd) -> 'c -> 'b


val array_of_rev_list: 'a list -> 'a array

val contains_spaces: string -> bool
val array_contains : 'a array -> 'a -> bool
val array_exists: ( 'a -> bool) -> 'a array -> bool


(* transforms '\\' to /  *)
val windows_mixed_path : string -> string



(* returns the current environment with the variable name replaced
   by value. If the variable doesn't exist yet, it will be
   append to the environment
val replaced_environment : name:string -> value:string -> string array *)


(* returns the current environment without the elements in the string list *)
val environment_with_removed_values : string list -> string array
