#ifdef _WIN32
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <sys/types.h>
#endif

#include <caml/alloc.h>
#include <caml/memory.h>
#include <caml/fail.h>
#include <caml/unixsupport.h>


#include "winkill.h"

CAMLprim value winkill(value vpid)
{
#ifdef _WIN32
  HANDLE pid_req = (HANDLE) Long_val(vpid);
  if (! TerminateProcess(pid_req, 0x80)) {
    win32_maperr(GetLastError());
    uerror("winkill", Nothing);
  }
#else
  caml_failwith("winkill is only avaiable on windows");
#endif
  return Val_unit;
}
