#!/bin/bash 

set -e
path="$(cygpath "$1")"
cygwinroot="$(readlink -f "$path")"
winroot="$(cygpath -m "$cygwinroot")"
winroot_bs="$(echo "$winroot" | sed 's|/|\\\\\\\\\\\\\\\\|g')"

tmpfile="$(mktemp)"

trap "rm -f \"$tmpfile\"" EXIT

confdat="${cygwinroot}/etc/godi.conf"

cp -p "${confdat}" "$tmpfile"

sed -e "s|^\s*LOCALBASE_NATIVE\s*=.*$|LOCALBASE_NATIVE = $winroot |" \
    -e "s|^\s*LOCALBASE_NATIVE_BS\s*=.*$|LOCALBASE_NATIVE_BS = $winroot_bs |" \
    -e "s|^\s*GODI_USER\s*=.*$|GODI_USER = anonymous |" \
    "$tmpfile"  > "$confdat"

dos2unix "${confdat}"

confdat="${cygwinroot}/etc/env_add"

cp -p "${confdat}" "$tmpfile"

docamllib="${winroot}/lib/ocaml/std-lib"
dcamomile_dir="${winroot}/share/camomile"
docamlnet_db_dir="${winroot}/share/godi-ocamlnet"

sed -e "s%^\s*OCAMLLIB|.*$%OCAMLLIB|${docamllib}%" \
    -e "s%^\s*CAMOMILE_DIR|.*$%CAMOMILE_DIR|${dcamomile_dir}%" \
    -e "s%^\s*OCAMLNET_DB_DIR|.*$%OCAMLNET_DB_DIR|${docamlnet_db_dir}%" \
    "$tmpfile"  > "$confdat"
