#! /bin/sh

set -e

uversion=$1

[ -z "$uversion" ] && exit 1

dir="$(dirname "$0")"
dir="$(cd "$dir" ; pwd)"
cd "$dir"

make distclean

#godi_root_dir="$(dirname "$(godi_confdir)")"
#version="$(cat "${godi_root_dir}/build/godi/godi-tools/.version")"
tmpdir="$(mktemp -d)"
tmpfile="$(mktemp)"

clean() {
    rm -rf "$tmpdir"
    rm -f "$tmpfile"
}

trap clean EXIT

nsource="${tmpdir}/godi-gtk"

mkdir -p "$nsource"

godi_pax -rw -pp . "$nsource"


debug_no() {
    while [ $# -gt 0 ]; do
        cp -p "$1" "$tmpfile"
        sed 's|DEBUG ?= yes|DEBUG ?= no|' "$tmpfile" > "${tmpdir}/godi-gtk/${1}"
        shift
    done
}

debug_no "Makefile.code" "installer/Makefile" "lib/Makefile"

#cp Makefile.gui "${tmpdir}/godi-tools-${version}/console-src"
#cp configure.gui "${tmpdir}/godi-tools-${version}"

tar --numeric-owner --format=ustar -C "${tmpdir}" -cf- "godi-gtk" | gzip -9 > "godi-gui-${uversion}.tar.gz"
