open Common
(* time consuming. Build an text index (Hashtbl) with all pre- and suffixes !
   Fast enough for the moment, because there are'nt much packages. No need for tries,...
*)

let rec iter_rebuild_ti htl i = function
| [] -> ()
| str::tl ->
  let str = String.lowercase str in
  let len = String.length str in
  for k = 0 to len - 1 do
    for j = 1 to len - k do
      let str = String.sub str k j in
      let ihtl =
        try
          SHashtbl.find htl str
        with
        | Not_found ->
          let ihtl = Hashtbl.create 2 in
          SHashtbl.add htl str ihtl ;
          ihtl
      in
      Hashtbl.replace ihtl i ()
    done;
  done;
  iter_rebuild_ti htl i tl


let space_regexp = Str.regexp "[ \t\n\x0B\x0C\r]+"
let space_split str = Str.split space_regexp str

let rebuild () =
  SHashtbl.clear Gl.text_index_src ;
  SHashtbl.clear Gl.text_index_bin ;
  let ar = !Gl.pkgs in
  for i = 0 to Array.length ar - 1 do
    let cur = ar.(i) in
    let htl = match cur.package_type with
    | PSource _ -> Gl.text_index_src
    | PBinary _ -> Gl.text_index_bin
    in
    iter_rebuild_ti htl i [cur.name ; cur.godi_maintainer ; cur.pretty_version ];
    iter_rebuild_ti htl i ^$ space_split cur.comment  ;
    iter_rebuild_ti htl i ^$ space_split cur.description  ;
    iter_rebuild_ti htl i ^$ space_split cur.install_message ;
  done
