#!/bin/bash

exe_file_gui=./godigui_opt.exe
exe_file_installer=./installer/installer_opt.exe
exe_inform=./installer/inform.exe

if [ -z "$OBJDUMP" ]; then
    echo "OBJDUMP not defined" >&2
    exit 1
fi

dir="$(dirname "$0")"
dir="$(cd "$dir" ; pwd)"
cd "$dir"

godi_root_dir="$(dirname "$(godi_confdir)")"
godi_gui_dir="${godi_root_dir}/gui"
godi_bin_dir="${godi_root_dir}/bin"

if [ ! -f "${exe_file_gui}" ] || [ ! -f "${exe_file_installer}" ] ; then
    echo "exe missing" >&2
    exit 1
fi

if ! mkdir -p "${godi_gui_dir}/bin" \
    "${godi_gui_dir}/etc" \
    "${godi_gui_dir}/share" \
    "${godi_gui_dir}/lib/gtk-2.0/2.10.0" \
    "${godi_gui_dir}/share/themes" \
    ; then
    exit 1
fi

cp -p "${exe_file_gui}" "${godi_gui_dir}/bin/gui.exe"
cp -p "${exe_file_installer}" "${godi_gui_dir}/bin/installer.exe"
cp "relocate.sh" "${exe_inform}" "${godi_gui_dir}/bin"

chmod 700 "${godi_gui_dir}/bin/relocate.sh"

cp -a "${godi_root_dir}/etc/fonts" "${godi_gui_dir}/etc"
cp -a "${godi_root_dir}/etc/gtk-2.0" "${godi_gui_dir}/etc"
cp -a "${godi_root_dir}/lib/gtk-2.0/2.10.0/engines" "${godi_gui_dir}/lib/gtk-2.0/2.10.0"
cp -a "${godi_root_dir}/lib/gtk-2.0/modules" "${godi_gui_dir}/lib/gtk-2.0"
cp -a "${godi_root_dir}/share/themes/MS-Windows" "${godi_gui_dir}/share/themes"
cp -a "pixmaps" "${godi_gui_dir}/share"

find "${godi_gui_dir}" -type l -delete
find "${godi_gui_dir}" -type f -name '*~' -delete
find "${godi_gui_dir}" -type f -name '*README*' -delete
find "${godi_gui_dir}" -type d -empty -delete

#1: found
#2: checked
declare -A mymap

oldIFS=$IFS
IFS='
'

for exe_file in "$exe_file_gui" "$exe_file_installer" ; do
    for dll in `$OBJDUMP -p "$exe_file" | grep 'DLL Name:' | awk '{print $3}'` ; do
	if [ -z "$dll" ] || [ ! -f "${godi_bin_dir}/${dll}" ] ; then
	    continue
	fi
	mymap[$dll]=1
    done
done


new_found=1
while [ $new_found -eq 1 ]; do
    new_found=0
    for dll in ${!mymap[@]} ; do
	value=${mymap[$dll]}
	if [ $value -eq 1 ]; then
	    mymap[$dll]=2
	    cp -p "${godi_bin_dir}/${dll}" "${godi_gui_dir}/bin"
	    for ndll in `$OBJDUMP -p "${godi_bin_dir}/${dll}" | grep 'DLL Name:' | awk '{print $3}'` ; do
		if [ -z "$ndll" ] || [ ! -f "${godi_bin_dir}/${ndll}" ] \
		    || [ "a${mymap[$ndll]}" = "a1" ] || [ "a${mymap[$ndll]}" = "a2" ] ; then
		    continue
		fi
		mymap[$ndll]=1
		new_found=1
	    done
	fi
    done
done

IFS=$oldIFS


exit 0
